<script setup lang="ts">
import StockDialog from '@/Stock/components/StockDialog.vue'
import { useStockStore } from '@/Stock/stores/stock'
import { onMounted, ref } from 'vue'
import EditStock from '../components/EditStock.vue'
const stockStore = useStockStore()

const showCard = ref(false)
const header = ['ID', 'Code', 'Name', 'Balance', 'Status']

onMounted(() => {
  stockStore.getAll()
})
</script>

<template>
  <StockDialog />
  <v-data-table class="h-100" fixed-header :headers="stockStore.headers" :items="stockStore.items">
    <!-- :search="search" -->
    <template #top>
      <v-card class="pa-5">
        <v-row>
          <v-col>
            <h2>Stock Management</h2>
          </v-col>
          <v-col cols="1"><v-btn @click="showCard = !showCard">Update</v-btn></v-col>
          <v-col cols="1">
            <router-link to="/management">
              <v-btn> Edit </v-btn>
            </router-link>
          </v-col>
          <!-- <v-col cols="1">
            <router-link to="/inventory">
              <v-btn > Inventory </v-btn>
            </router-link>
          </v-col> -->
          <v-col cols="1">
            <v-btn @click="stockStore.openDialog()">New</v-btn>
          </v-col>
        </v-row>
      </v-card>
    </template>

    <template #item="{ item }">
      <tr @click="stockStore.editItem(item)">
        <td>{{ item.id }}</td>
        <td>{{ item.code }}</td>
        <td>{{ item.name }}</td>
        <td>{{ item.price }}</td>
        <td>{{ item.balance }}</td>
        <td>{{ item.unit }}</td>
        <td>{{ item.status }}</td>
        <td>
          <v-icon
            size="small"
            class="me-2"
            @click="stockStore.editItem(item), stockStore.openDialog()"
          >
            mdi-pencil
          </v-icon>
          <v-icon size="small" @click="stockStore.deleteItem(item)"> mdi-delete </v-icon>
        </td>
      </tr>
    </template>
  </v-data-table>
  <v-card
    v-show="showCard"
    v-model:model-value="stockStore.openEdit"
    class="pa-5"
    title="Edit Stock"
  >
    <v-card-text>
      <v-container>
        <v-row>
          <v-col cols="12">
            <v-table>
              <thead>
                <tr>
                  <th class="bg-brown" v-for="h in header" :key="h">{{ h }}</th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td>{{ stockStore.stockItem.id }}</td>
                  <td>{{ stockStore.stockItem.code }}</td>
                  <td>{{ stockStore.stockItem.name }}</td>
                  <td>
                    <v-text-field v-model="stockStore.stockItem.balance" label="Balance">
                    </v-text-field>
                  </td>
                  <td>
                    <!-- <v-combobox
                      v-model="stockStore.stockItem.status"
                      :items="[
                        { title: 'L', value: 'L' },
                        { title: 'M', value: 'M' }
                      ]"
                      label="status"
                      :return-object="false"
                    ></v-combobox> -->
                    {{ stockStore.stockItem.status }}
                  </td>
                </tr>
              </tbody>
            </v-table>
          </v-col>
        </v-row>
      </v-container>
    </v-card-text>

    <template #actions>
      <v-row justify="end">
        <v-btn @click="stockStore.closeDialog(), (showCard = false)"> Cancel </v-btn>
        <v-btn @click="stockStore.save(), stockStore.updateStatus()"> Save </v-btn>
      </v-row>
    </template>
  </v-card>
</template>

<style scoped></style>
